package org.gcube.accounting.datamodel.validations.validators;

import java.io.Serializable;

import org.gcube.accounting.datamodel.UsageRecord.OperationResult;
import org.gcube.accounting.exception.InvalidValueException;

public class ValidOperationResultValidator implements FieldValidator {

	private static final String ERROR = String.format("Not Instance of %s", OperationResult.class.getSimpleName());
	
	@Override
	public Serializable validate(Serializable toValidate) throws InvalidValueException {
		if(toValidate instanceof OperationResult){
			return toValidate;
		}
		
		try {
			if(toValidate instanceof String){
				try{
					OperationResult operationResult = OperationResult.valueOf((String) toValidate);
					if(operationResult !=null){
						return operationResult;
					}
				} catch(Exception e){
					// Trying another way
				}
				
				try{
					Integer integer = Integer.getInteger((String) toValidate);
					if(integer!=null){
						toValidate = integer;
					}
				} catch(Exception e){
					// Trying another way
				}
			}
			
			if(toValidate instanceof Integer){
				return OperationResult.values()[(Integer) toValidate];
			}
			
		}catch(Exception e){
			throw new InvalidValueException(ERROR, e.getCause());
		}
		
		throw new InvalidValueException(ERROR);
	}
	

}
